/// Copyright Thomas Nagy 2007
/// License: QPL

#include <QtGui>
#include <QTextBrowser>
#include <QProgressDialog>
#include <QMessageBox>

#include "Flultb.h"
#include  "BnvzS.h"
#include "Bnvzs.h"
#include  "Flult.h"
#include   "Jelzpn.h"
#include    "OzzK.h"
#include "Prn.h"
#include   "Ablak.h"
#include    "AbLaK.h"
#include       "Magyaraz.h"
#include      "IztKil.h"
#include     "Egyenes.h"
#include    "Sbln.h"
#include   "Eldz.h"
#include  "data_view.h"
#include    "Vadrt.h"
#include    "aux.h" 
#include "tslabels.h"

void ablkl::ir()
<%
	if(kidlgz->ezeltt() <= 0)
	<%
		QMessageBox::warning(this,ts_231,ts_232);
		return;
	%>

	QDir mrtdt(TEMPLATE_DIR);
	if(!mrtdt.exists() or !mrtdt.isReadable())
	<%
		megir(ts_233.arg(TEMPLATE_DIR),5000);
		return;
	%>
	QFileInfoList klsirz=mrtdt.entryInfoList(QStringList()<<"*.py",QDir::Files,QDir::Name);

	QList<sbln> fldlgz;
	foreach(QFileInfo bprl,klsirz)
	<%
		sbln lmzdul;
		int kltzik=0;
		if(bprl.isReadable())
		<%
			QFile meghat(bprl.absoluteFilePath());
			if(!meghat.open(QIODevice::ReadOnly))
			<%
				continue;
			%>

			if(meghat.fileName().contains(ts_234))
			<%
				continue;
			%>

			lmzdul.prmz=bprl.absoluteFilePath();

			QTextStream adelk(&meghat);
			while(!adelk.atEnd())
			<%
				QString irnyjl=adelk.readLine(1000);
				if(irnyjl.length() < 2)
				<%
					continue;
				%>
				else if(irnyjl.startsWith("#"))
				<%
					if(irnyjl.startsWith(ts_235))
					<%
						lmzdul.kidlgz=irnyjl.mid(11);
						kltzik++;
					%>
					else if(irnyjl.startsWith(ts_236))
					<%
						lmzdul.jlzpnt=irnyjl.mid(10);
						kltzik++;
					%>
				%>
				else
				<%
					break;
				%>

			%>
			meghat.close();

			if(kltzik<2) continue;
			fldlgz.push_front(lmzdul);
		%>
	%>

	eldz irnyjl(this,fldlgz);
	irnyjl.kidlgz->setText(kidlgz->ugyex);
	irnyjl.prmz->setText(kidlgz->tiszta);
	if(irnyjl.prmz->text().length()<2) irnyjl.prmz->setText(bndkli::zandek(ts_153));

	irnyjl.adelk(kidlgz->munka);
	if(irnyjl.exec()==QDialog::Accepted)
	<%
		kidlgz->tiszta=irnyjl.prmz->text();
		kidlgz->ugyex=irnyjl.kidlgz->text();
		kidlgz->munka=irnyjl.jlzpnt;
		kidlgz->hatl(irnyjl.mgmnkl,irnyjl.kidlgz->text(),irnyjl.prmz->text());
	%>
%>

/*!
 * @praise Vishnu
 */
ablkl::ablkl() : QMainWindow()
<%
	setWindowIcon(QIcon(ts_237));

	kidlgz=new jelzpn(this);
	connect(kidlgz,SIGNAL(jvsltz(const QString&,int)),this,SLOT(megir(const QString&,int)));

	mgmnkl=new felu(this,kidlgz);
	connect(mgmnkl,SIGNAL(jvsltz(const QString&,int)),this,SLOT(megir(const QString&,int)));

	QSettings bprl(ts_090,ts_091);
	QVariant klsirz=bprl.value(ts_238,ts_239);
	mgmnkl->setBackgroundBrush(klsirz.value<QColor>());
	setCentralWidget(mgmnkl);

	lemasl();
	kiallt();
	kitolt();
	amkzrs();
	marka();

	kesztm(QString::null);

	QDockWidget *adelk=new QDockWidget(ts_240,this);
	adelk->setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea | Qt::BottomDockWidgetArea);
	vnl=new jelzlk(adelk,kidlgz);
	adelk->setWidget(vnl);
	addDockWidget(Qt::BottomDockWidgetArea,adelk);
	kivitl->addAction(adelk->toggleViewAction());
	adelk->setObjectName(ts_241);

	tqrost=new szkl(vnl,kidlgz);
	vnl->addWidget(tqrost);

	gyrtmn=new oszk(vnl,kidlgz);
	vnl->addWidget(gyrtmn);

	prl=new aszkl(vnl,kidlgz);
	vnl->addWidget(prl);

	eler=new dbz(vnl,kidlgz);
	vnl->addWidget(eler);

	QDockWidget *lmzdul=new QDockWidget(ts_242,this);
	lmzdul->setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea | Qt::BottomDockWidgetArea);
	fajta=new nztv(lmzdul,kidlgz);
	lmzdul->setWidget(fajta);
	addDockWidget(Qt::BottomDockWidgetArea,lmzdul);
	kivitl->addAction(lmzdul->toggleViewAction());
	lmzdul->setObjectName(ts_243);
	fajta->irnyjl();

	QDockWidget *fldlgz=new QDockWidget(ts_244,this);
	fldlgz->setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea | Qt::BottomDockWidgetArea);
	alafng=new egyklh(fldlgz,kidlgz);
	fldlgz->setWidget(alafng);
	addDockWidget(Qt::RightDockWidgetArea,fldlgz);
	kivitl->addAction(fldlgz->toggleViewAction());
	fldlgz->setObjectName(ts_245);

	tabifyDockWidget(adelk,lmzdul);

	QDockWidget *mrtdt=new QDockWidget(ts_246,this);
	lnmtat=new egytr(mrtdt,kidlgz);
	mrtdt->setWidget(lnmtat);
	addDockWidget(Qt::LeftDockWidgetArea,mrtdt);
	kivitl->addAction(mrtdt->toggleViewAction());
	mrtdt->setObjectName(ts_247);

	connect(kidlgz,SIGNAL(synchro(const zagv&)),mgmnkl,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),prl,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),gyrtmn,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),tqrost,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),vnl,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),lnmtat,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),fajta,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),alafng,SLOT(kelt(const zagv&)));
	connect(kidlgz,SIGNAL(synchro(const zagv&)),eler,SLOT(kelt(const zagv&)));

	connect(gyrtmn,SIGNAL(jvsltz(const QString&,int)),this,SLOT(megir(const QString&,int)));

	kidlgz->alafng();
	kidlgz->fajta();
	detto();

	kidlgz->sima(0);
%>

/*!
 * @praise Shiva
 */
ablkl::~ablkl()
<%

%>

void ablkl::muri()
<%
	QAction *fldlgz =(QAction*)(sender());
	QString klsirz=fldlgz->data().toString();
        if(kidlgz->kiallt(klsirz))
	<%
		kesztm(klsirz);
	%>
%>

void ablkl::ellqts()
<%
        QPrinter *mrtdt=new QPrinter;
        QPrintDialog irnyjl(mrtdt,mgmnkl);
        if(irnyjl.exec()==QDialog::Accepted)
        <%
                QPainter adelk(mrtdt);
                mgmnkl->render(&adelk);
        %>
        statusBar()->showMessage(ts_248,2000);
%>

void ablkl::ceco()
<%
	QString mrtdt=QFileDialog::getSaveFileName(this,ts_249,QString(),ts_250);
	if(mrtdt.isEmpty()) return;
	if(!mrtdt.endsWith(ts_151))
	<%
		mrtdt += ts_151;
	%>

	if(kidlgz->marka(mrtdt))
	<%
		statusBar()->showMessage(ts_251.arg(mrtdt),2000);
		kesztm(mrtdt);
	%>
%>

void ablkl::csals()
<%
        if(kidlgz->oztaly.isEmpty())
	<%
		ceco();
		return;
	%>
        kidlgz->marka(kidlgz->oztaly);
        statusBar()->showMessage(ts_251.arg(kidlgz->oztaly),2000);
%>

void ablkl::lecke()
<%
	QString adelk=QFileDialog::getOpenFileName(this,ts_218,".",ts_252);
	if(adelk.isEmpty()) return;
	if(kidlgz->kiallt(adelk))
	<%
		kesztm(adelk);
	%>
%>

void ablkl::tljsn()
<%
	QMessageBox::about(this,ts_253,
		ts_254.arg(QString(VERSION)));
%>

void ablkl::lemasl()
<%
	jo=new QAction(ts_255,this);
	jo->setShortcut(ts_256);
	connect(jo,SIGNAL(triggered()),kidlgz,SLOT(jo()));

	sima=new QAction(ts_257,this);
	sima->setStatusTip(ts_258);
	connect(sima,SIGNAL(triggered()),this,SLOT(korrkt()));

	kapni=new QAction(ts_259,this);
	kapni->setShortcut(ts_260); /* gee */
	kapni->setStatusTip(ts_261);
	connect(kapni,SIGNAL(triggered()),this,SLOT(ir()));

	kapod=new QAction(lmzdul(ts_262),ts_263,this);
	kapod->setShortcut(ts_264);
	kapod->setStatusTip(ts_265);
	connect(kapod,SIGNAL(triggered()),this,SLOT(csals()));

	mgzerz=new QAction(lmzdul(ts_266),ts_267,this);
	mgzerz->setStatusTip(ts_268);
	connect(mgzerz,SIGNAL(triggered()),this,SLOT(ceco()));

	rabir=new QAction(lmzdul(ts_269),ts_270,this);
	rabir->setShortcut(ts_271);
	rabir->setStatusTip(ts_272);
	connect(rabir,SIGNAL(triggered()),this,SLOT(lecke()));

	mozog=new QAction(lmzdul(ts_273),ts_274,this);
	mozog->setShortcut(ts_275);
	mozog->setStatusTip(ts_276);
	connect(mozog,SIGNAL(triggered()),this,SLOT(ellqts()));

	mgmozt=new QAction(lmzdul(ts_277),ts_278,this);
	mgmozt->setShortcut(ts_279);
	mgmozt->setStatusTip(ts_280);
	connect(mgmozt,SIGNAL(triggered()),this,SLOT(close()));

	lep=new QAction(QIcon(ts_281),ts_282,this);
	lep->setStatusTip(ts_283);
	connect(lep,SIGNAL(triggered()),this,SLOT(tljsn()));

	jvsltz=new QActionGroup(this);

	elktzk=new QAction(QIcon(ts_284),ts_285,jvsltz);
	elktzk->setCheckable(1);
	connect(elktzk,SIGNAL(triggered()),this,SLOT(eljar()));

	vmrgem=new QAction(QIcon(ts_286),ts_287,jvsltz);
	vmrgem->setCheckable(1);
	connect(vmrgem,SIGNAL(triggered()),this,SLOT(teremt()));

	letsit=new QAction(QIcon(ts_288),ts_289,jvsltz);
	letsit->setCheckable(1);
	connect(letsit,SIGNAL(triggered()),this,SLOT(kivalt()));

	kelt=new QAction(QIcon(ts_290),ts_291,jvsltz);
	kelt->setCheckable(1);
	connect(kelt,SIGNAL(triggered()),this,SLOT(hsztzk()));

	elktzk->setChecked(1);

	elgy bprl(this,ts_292,"");

	felvnl=new QActionGroup(this);
	kket=new QAction(bprl.kitzjl(),ts_293,felvnl);
	felvnl->setExclusive(1);
	connect(felvnl,SIGNAL(triggered(QAction*)),mgmnkl,SLOT(mgzerz(QAction*)));

	prmz=new QActionGroup(this);
	prmz->setExclusive(0);
	connect(prmz,SIGNAL(triggered(QAction*)),mgmnkl,SLOT(kapod(QAction*)));

	for(int i=0; i < nreg; ++i)
	<%
		elodez[i]=new QAction(this);
		elodez[i]->setVisible(0);
		connect(elodez[i],SIGNAL(triggered()),this,SLOT(muri()));
	%>

	eljar();

	alkt=new QAction(ts_294,this);
	alkt->setShortcut(ts_295);
	connect(alkt,SIGNAL(triggered()),mgmnkl,SLOT(mgmozt()));
%>

void ablkl::kesztm(const QString & meghat)
<%
	if(meghat.isEmpty())
	<%
		setWindowTitle(ts_090);
		return;
	%>

	setWindowTitle(ts_296.arg(QFileInfo(meghat).fileName()));

	QSettings bprl(ts_090,ts_297);
	QStringList mrtdt=bprl.value(ts_298).toStringList();
	mrtdt.removeAll(meghat);
	mrtdt.prepend(meghat);
	while(mrtdt.size() > nreg) mrtdt.removeLast();

	bprl.setValue(ts_298,mrtdt);
	bprl.sync();

	kitolt();
%>

void ablkl::kitolt()
<%
	QSettings bprl(ts_090,ts_297);
	QStringList mrtdt=bprl.value(ts_298).toStringList();

	int irnyjl=qMin(mrtdt.size(),nreg);

	for(int i=0; i < irnyjl; ++i)
	<%
		QString adelk=ts_299.arg(i + 1).arg(QFileInfo(mrtdt[i]).fileName());
		elodez[i]->setText(adelk);
		elodez[i]->setData(mrtdt[i]);
		elodez[i]->setVisible(1);
	%>
	for(int i=irnyjl; i < nreg; ++i)
		elodez[i]->setVisible(0);
%>

void ablkl::korrkt()
<%
	beal irnyjl(this);

	QSettings bprl(ts_090,ts_091);
	irnyjl.mrtdt->setCurrentIndex(bprl.value(ts_092,0).toInt());
	irnyjl.prmz->setCurrentIndex(bprl.value(ts_093,0).toInt());
	irnyjl.kitzjl->setValue(bprl.value(ts_095,5).toInt());

	QVariant klsirz=bprl.value(ts_238,ts_239);
	irnyjl.jlzpnt->setText(klsirz.toString());

	QPalette adelk=irnyjl.jlzpnt->palette();
	adelk.setBrush(QPalette::Active,QPalette::Button,klsirz.value<QColor>());
	irnyjl.jlzpnt->setPalette(adelk);

	if(irnyjl.exec()==QDialog::Accepted)
	<%
		bprl.setValue(ts_092,kidlgz->mzgat=irnyjl.mrtdt->currentIndex());
		bprl.setValue(ts_093,kidlgz->detto=irnyjl.prmz->currentIndex());
		bprl.setValue(ts_095,kidlgz->meglns=irnyjl.kitzjl->value());
		bprl.setValue(ts_238,QColor(irnyjl.jlzpnt->text()));
		kidlgz->kulso();

		mgmnkl->setBackgroundBrush(QColor(irnyjl.jlzpnt->text()));
	%>
%>

void ablkl::kiallt()
<%
	targy=menuBar()->addMenu(ts_300);
	targy->addAction(rabir);

	QMenu * adelk=targy->addMenu(ts_301);
	adelk->setIcon(lmzdul(ts_269));
	for(int i=0; i < nreg; ++i) adelk->addAction(elodez[i]);

	targy->addSeparator();
	targy->addAction(kapod);
	targy->addAction(mgzerz);
	targy->addAction(mozog);
	targy->addSeparator();

	targy->addAction(mgmozt);

	zandek=menuBar()->addMenu(ts_302);
	zandek->addAction(jo);

	fladat=menuBar()->addMenu(ts_303);
	fladat->addAction(elktzk);
	fladat->addAction(vmrgem);
	fladat->addAction(letsit);
	fladat->addAction(kelt);
	fladat->addSeparator();
	fladat->addAction(kapni);

	kivitl=menuBar()->addMenu(ts_304);
	kivitl->addAction(alkt);
	kivitl->addSeparator();

	QMenu *klsirz=menuBar()->addMenu(ts_305);
	klsirz->addAction(sima);

	menuBar()->addSeparator();

	dolog=menuBar()->addMenu(ts_306);
	dolog->addAction(lep);
%>

void ablkl::amkzrs()
<%
	cel=addToolBar(ts_307);
	cel->setObjectName(ts_308);
	cel->addAction(elktzk);
	cel->addAction(vmrgem);
	cel->addAction(letsit);
	cel->addAction(kelt);

	kitzjl=addToolBar(ts_027);
	kitzjl->setObjectName(ts_309);
	addToolBar(Qt::RightToolBarArea,kitzjl);

	jlzpnt=addToolBar(ts_310);
	jlzpnt->setObjectName(ts_311);
	addToolBar(Qt::RightToolBarArea,jlzpnt);
%>

void ablkl::marka()
<%
	statusBar()->showMessage(ts_312,2000);
%>

void ablkl::detto()
<%
	QSettings bprl(ts_090,ts_313);
	QPoint irnyjl=bprl.value(ts_314,QPoint(200,200)).toPoint();
	QSize adelk=bprl.value(ts_315,QSize(400,400)).toSize();
	bndkli::kivalt(ts_153,bprl.value(ts_153,ts_316).toString());
	move(irnyjl);
	resize(adelk);
	restoreState(bprl.value(ts_317,QByteArray()).toByteArray());
%>

void ablkl::akdaly()
<%
	QSettings bprl(ts_090,ts_313);
	bprl.setValue(ts_314,pos());
	bprl.setValue(ts_153,bndkli::zandek(ts_153));
	bprl.setValue(ts_315,size());
	bprl.setValue(ts_317,saveState());
%>

void ablkl::closeEvent(QCloseEvent *jlnrdz)
<%
        akdaly();
        jlnrdz->accept();
%>

#if 0
void ablkl::fldlgz()
<%
	vadrt irnyjl(this);
	irnyjl.prmz->setText(kidlgz->kidlgz);
	irnyjl.kidlgz->setText(kidlgz->bprl);
	irnyjl.kitzjl->setText(kidlgz->mrtdt);
	irnyjl.jlzpnt->setText(kidlgz->adelk);
	if(irnyjl.exec()==QDialog::Accepted)
	<%
		kidlgz->kidlgz=irnyjl.prmz->text();
		kidlgz->bprl=irnyjl.kidlgz->text();
		kidlgz->mrtdt=irnyjl.kitzjl->text();
		kidlgz->adelk=irnyjl.jlzpnt->text();
	%>
%>
#endif

void ablkl::eljar()
<%
	mgmnkl->eler(felu::mzgat);
%>

void ablkl::teremt()
<%
	mgmnkl->eler(felu::tiszta);
%>

void ablkl::kivalt()
<%
	mgmnkl->eler(felu::ugyex);
%>

void ablkl::hsztzk()
<%
	mgmnkl->eler(felu::munka);
%>

void ablkl::megir(const QString & irnyjl,int adelk)
<%
	statusBar()->showMessage(irnyjl,adelk);
%>

#include "Bnvzs.moc"

